Index: trunk/sources/HeuristicLab.Hive.Client.Common/HeuristicLab.Hive.Client.Common.csproj
===================================================================
--- trunk/sources/HeuristicLab.Hive.Client.Common/HeuristicLab.Hive.Client.Common.csproj	(revision 818)
+++ trunk/sources/HeuristicLab.Hive.Client.Common/HeuristicLab.Hive.Client.Common.csproj	(revision 819)
@@ -66,11 +66,8 @@
   <ItemGroup>
     <Compile Include="CommonPlugin.cs" />
-    <Compile Include="Interfaces\IJob.cs" />
-    <Compile Include="JobBase.cs" />
     <Compile Include="Logging.cs" />
     <Compile Include="MessageQueue.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="Status.cs" />
-    <Compile Include="TestJob.cs" />
   </ItemGroup>
   <ItemGroup>
@@ -92,4 +89,7 @@
     <None Include="Properties\AssemblyInfo.frame" />
   </ItemGroup>
+  <ItemGroup>
+    <Folder Include="Interfaces\" />
+  </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
Index: trunk/sources/HeuristicLab.Hive.Client.Common/Interfaces/IJob.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Client.Common/Interfaces/IJob.cs	(revision 818)
+++ 	(revision )
@@ -1,13 +1,0 @@
-﻿using System;
-using HeuristicLab.Core;
-namespace HeuristicLab.Hive.Client.Common {
-  public interface IJob: IStorable {
-    event EventHandler JobStopped;
-    long JobId { get; set; }
-    double Progress { get; set; }
-    void Run();
-    bool Running { get; set; }
-    void Start();
-    void Stop();
-  }
-}
Index: trunk/sources/HeuristicLab.Hive.Client.Common/JobBase.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Client.Common/JobBase.cs	(revision 818)
+++ 	(revision )
@@ -1,82 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using System.Threading;
-using System.Xml;
-using HeuristicLab.Core;
-using HeuristicLab.Hive.Client.Common;
-
-namespace HeuristicLab.Hive.Client.Common {
-  [Serializable]
-  abstract public class JobBase : StorableBase, IJob {
-
-    private Thread thread = null;
-    public event EventHandler JobStopped;
-    
-    public long JobId { get; set; }    
-    public double Progress { get; set; }        
-    public bool Running { get; set; }
-    
-    protected bool abort = false;    
-
-    abstract public void Run();
-
-    public void Start() {
-      thread = new Thread(new ThreadStart(Run));
-      thread.Start();
-      Running = true;
-    }
-
-    public void Stop() {
-      abort = true;        
-    }
-
-    protected void OnJobStopped() {
-      Console.WriteLine("Job has finished");
-      Running = false;
-      if (JobStopped != null)
-        JobStopped(this, new EventArgs());
-    }
-
-    public override XmlNode GetXmlNode(string name, XmlDocument document, IDictionary<Guid, IStorable> persistedObjects) {
-      XmlNode node = base.GetXmlNode(name, document, persistedObjects);
-
-      XmlNode progr = document.CreateNode(XmlNodeType.Element, "Progress", null);
-      progr.InnerText = Convert.ToString(Progress);
-
-      node.AppendChild(progr);
-      return node;
-    }
-    public override void Populate(XmlNode node, IDictionary<Guid, IStorable> restoredObjects) {
-      base.Populate(node, restoredObjects);
-
-      XmlNode progr = node.SelectSingleNode("Progress");
-      Progress = Convert.ToDouble(progr.InnerText);
-    }
-
-    public JobBase() {    
-    }
-  }
-}
Index: trunk/sources/HeuristicLab.Hive.Client.Common/TestJob.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Client.Common/TestJob.cs	(revision 818)
+++ 	(revision )
@@ -1,71 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using System.Diagnostics;
-using System.Xml;
-
-namespace HeuristicLab.Hive.Client.Common {
-  [Serializable]
-  public class TestJob: JobBase {
-
-    private int runValue = 0;
-
-    public override void Run() {
-      int max = 10;
-      while(runValue < max && abort == false) {
-        for (int y = 0; y < Int32.MaxValue; y++) ;
-          if (abort == true) {
-            Logging.GetInstance().Info(this.ToString(), "Job Processing aborted");
-            Debug.WriteLine("Job Abort Processing");
-           break;
-          }
-        runValue++;
-        Progress = runValue / max;
-        Logging.GetInstance().Info(this.ToString(), "Iteration " + runValue + " done");
-        Debug.WriteLine("Iteration " + runValue + " done");
-        Debug.WriteLine("Progress " + Progress*100 + " Percent");
-      }      
-      OnJobStopped();
-    }
-    public override System.Xml.XmlNode GetXmlNode(string name, System.Xml.XmlDocument document, IDictionary<Guid, HeuristicLab.Core.IStorable> persistedObjects) {      
-      XmlNode node = base.GetXmlNode(name, document, persistedObjects);
-    
-      XmlNode startValue = document.CreateNode(XmlNodeType.Element, "StartValue", null);
-      startValue.InnerText = Convert.ToString(runValue);
-      
-      node.AppendChild(startValue);
-      return node;
-    }
-
-    public override void Populate(XmlNode node, IDictionary<Guid, HeuristicLab.Core.IStorable> restoredObjects) {
-      base.Populate(node, restoredObjects);
-
-      XmlNode startValue = node.SelectSingleNode("StartValue");
-      runValue = Convert.ToInt32(startValue.InnerText);
-    }
-
-
-  }
-}
Index: trunk/sources/HeuristicLab.Hive.Client.Communication/ServiceLocator.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Client.Communication/ServiceLocator.cs	(revision 818)
+++ trunk/sources/HeuristicLab.Hive.Client.Communication/ServiceLocator.cs	(revision 819)
@@ -13,5 +13,5 @@
         proxy = new ClientCommunicatorClient(
           new NetTcpBinding(),
-          new EndpointAddress("net.tcp://192.168.132.1:9000/HiveServer/ClientCommunicator")
+          new EndpointAddress("net.tcp://10.20.53.1:9000/HiveServer/ClientCommunicator")
           );
       }
Index: trunk/sources/HeuristicLab.Hive.Contracts/HeuristicLab.Hive.Contracts.csproj
===================================================================
--- trunk/sources/HeuristicLab.Hive.Contracts/HeuristicLab.Hive.Contracts.csproj	(revision 818)
+++ trunk/sources/HeuristicLab.Hive.Contracts/HeuristicLab.Hive.Contracts.csproj	(revision 819)
@@ -67,8 +67,10 @@
     <Compile Include="BusinessObjects\User.cs" />
     <Compile Include="BusinessObjects\UserGroup.cs" />
+    <Compile Include="Interfaces\IJob.cs" />
     <Compile Include="Interfaces\IClientManager.cs" />
     <Compile Include="Interfaces\IJobManager.cs" />
     <Compile Include="Interfaces\IServerConsoleFacade.cs" />
     <Compile Include="Interfaces\IUserRoleManager.cs" />
+    <Compile Include="JobBase.cs" />
     <Compile Include="MessageContainer.cs" />
     <Compile Include="ResponseJob.cs" />
@@ -78,6 +80,11 @@
     <Compile Include="Response.cs" />
     <Compile Include="ResponseHB.cs" />
+    <Compile Include="TestJob.cs" />
   </ItemGroup>
   <ItemGroup>
+    <ProjectReference Include="..\HeuristicLab.Core\HeuristicLab.Core.csproj">
+      <Project>{F43B59AB-2B8C-4570-BC1E-15592086517C}</Project>
+      <Name>HeuristicLab.Core</Name>
+    </ProjectReference>
     <ProjectReference Include="..\HeuristicLab.PluginInfrastructure\HeuristicLab.PluginInfrastructure.csproj">
       <Project>{94186A6A-5176-4402-AE83-886557B53CCA}</Project>
Index: trunk/sources/HeuristicLab.Hive.Contracts/Interfaces/IJob.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Contracts/Interfaces/IJob.cs	(revision 819)
+++ trunk/sources/HeuristicLab.Hive.Contracts/Interfaces/IJob.cs	(revision 819)
@@ -0,0 +1,13 @@
+﻿using System;
+using HeuristicLab.Core;
+namespace HeuristicLab.Hive.Client.Common {
+  public interface IJob: IStorable {
+    event EventHandler JobStopped;
+    long JobId { get; set; }
+    double Progress { get; set; }
+    void Run();
+    bool Running { get; set; }
+    void Start();
+    void Stop();
+  }
+}
Index: trunk/sources/HeuristicLab.Hive.Contracts/JobBase.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Contracts/JobBase.cs	(revision 819)
+++ trunk/sources/HeuristicLab.Hive.Contracts/JobBase.cs	(revision 819)
@@ -0,0 +1,82 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading;
+using System.Xml;
+using HeuristicLab.Core;
+using HeuristicLab.Hive.Client.Common;
+
+namespace HeuristicLab.Hive.Client.Common {
+  [Serializable]
+  abstract public class JobBase : StorableBase, IJob {
+
+    private Thread thread = null;
+    public event EventHandler JobStopped;
+    
+    public long JobId { get; set; }    
+    public double Progress { get; set; }        
+    public bool Running { get; set; }
+    
+    protected bool abort = false;    
+
+    abstract public void Run();
+
+    public void Start() {
+      thread = new Thread(new ThreadStart(Run));
+      thread.Start();
+      Running = true;
+    }
+
+    public void Stop() {
+      abort = true;        
+    }
+
+    protected void OnJobStopped() {
+      Console.WriteLine("Job has finished");
+      Running = false;
+      if (JobStopped != null)
+        JobStopped(this, new EventArgs());
+    }
+
+    public override XmlNode GetXmlNode(string name, XmlDocument document, IDictionary<Guid, IStorable> persistedObjects) {
+      XmlNode node = base.GetXmlNode(name, document, persistedObjects);
+
+      XmlNode progr = document.CreateNode(XmlNodeType.Element, "Progress", null);
+      progr.InnerText = Convert.ToString(Progress);
+
+      node.AppendChild(progr);
+      return node;
+    }
+    public override void Populate(XmlNode node, IDictionary<Guid, IStorable> restoredObjects) {
+      base.Populate(node, restoredObjects);
+
+      XmlNode progr = node.SelectSingleNode("Progress");
+      Progress = Convert.ToDouble(progr.InnerText);
+    }
+
+    public JobBase() {    
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Hive.Contracts/TestJob.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Contracts/TestJob.cs	(revision 819)
+++ trunk/sources/HeuristicLab.Hive.Contracts/TestJob.cs	(revision 819)
@@ -0,0 +1,69 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Diagnostics;
+using System.Xml;
+
+namespace HeuristicLab.Hive.Client.Common {
+  [Serializable]
+  public class TestJob: JobBase {
+
+    private int runValue = 0;
+
+    public override void Run() {
+      int max = 10;
+      while(runValue < max && abort == false) {
+        for (int y = 0; y < Int32.MaxValue; y++) ;
+          if (abort == true) {            
+            Debug.WriteLine("Job Abort Processing");
+           break;
+          }
+        runValue++;
+        Progress = (double)runValue / max;        
+        Debug.WriteLine("Iteration " + runValue + " done");
+        Debug.WriteLine("Progress " + Progress*100 + " Percent");
+      }      
+      OnJobStopped();
+    }
+    public override System.Xml.XmlNode GetXmlNode(string name, System.Xml.XmlDocument document, IDictionary<Guid, HeuristicLab.Core.IStorable> persistedObjects) {      
+      XmlNode node = base.GetXmlNode(name, document, persistedObjects);
+    
+      XmlNode startValue = document.CreateNode(XmlNodeType.Element, "StartValue", null);
+      startValue.InnerText = Convert.ToString(runValue);
+      
+      node.AppendChild(startValue);
+      return node;
+    }
+
+    public override void Populate(XmlNode node, IDictionary<Guid, HeuristicLab.Core.IStorable> restoredObjects) {
+      base.Populate(node, restoredObjects);
+
+      XmlNode startValue = node.SelectSingleNode("StartValue");
+      runValue = Convert.ToInt32(startValue.InnerText);
+    }
+
+
+  }
+}