Index: /trunk/sources/HeuristicLab.Hive.Server.Console/HiveServerConsole.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.Console/HiveServerConsole.cs	(revision 830)
+++ /trunk/sources/HeuristicLab.Hive.Server.Console/HiveServerConsole.cs	(revision 831)
@@ -60,10 +60,4 @@
         ServiceLocator.Port = this.tbPort.Text;
 
-        IClientManager clientManager =
-          ServiceLocator.GetClientManager();
-
-        List<ClientInfo> clients = 
-          clientManager.GetAllClients();
-
         this.Visible = false;
         information = new HiveServerManagementConsole();
Index: /trunk/sources/HeuristicLab.Hive.Server.Console/HiveServerManagementConsole.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.Console/HiveServerManagementConsole.Designer.cs	(revision 830)
+++ /trunk/sources/HeuristicLab.Hive.Server.Console/HiveServerManagementConsole.Designer.cs	(revision 831)
@@ -30,13 +30,13 @@
       this.tpClientControl = new System.Windows.Forms.TabPage();
       this.scClientControl = new System.Windows.Forms.SplitContainer();
-      this.treeView1 = new System.Windows.Forms.TreeView();
+      this.tvClientControl = new System.Windows.Forms.TreeView();
       this.listView1 = new System.Windows.Forms.ListView();
       this.tpJobControl = new System.Windows.Forms.TabPage();
       this.scJobControl = new System.Windows.Forms.SplitContainer();
-      this.treeView3 = new System.Windows.Forms.TreeView();
+      this.tvJobControl = new System.Windows.Forms.TreeView();
       this.listView3 = new System.Windows.Forms.ListView();
       this.tpUserControl = new System.Windows.Forms.TabPage();
       this.scUserControl = new System.Windows.Forms.SplitContainer();
-      this.treeView4 = new System.Windows.Forms.TreeView();
+      this.tvUserControl = new System.Windows.Forms.TreeView();
       this.listView4 = new System.Windows.Forms.ListView();
       this.treeView2 = new System.Windows.Forms.TreeView();
@@ -79,5 +79,5 @@
       // 
       this.closeToolStripMenuItem.Name = "closeToolStripMenuItem";
-      this.closeToolStripMenuItem.Size = new System.Drawing.Size(152, 22);
+      this.closeToolStripMenuItem.Size = new System.Drawing.Size(111, 22);
       this.closeToolStripMenuItem.Text = "Close";
       this.closeToolStripMenuItem.Click += new System.EventHandler(this.close_Click);
@@ -115,5 +115,5 @@
       // scClientControl.Panel1
       // 
-      this.scClientControl.Panel1.Controls.Add(this.treeView1);
+      this.scClientControl.Panel1.Controls.Add(this.tvClientControl);
       // 
       // scClientControl.Panel2
@@ -124,11 +124,11 @@
       this.scClientControl.TabIndex = 0;
       // 
-      // treeView1
-      // 
-      this.treeView1.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.treeView1.Location = new System.Drawing.Point(0, 0);
-      this.treeView1.Name = "treeView1";
-      this.treeView1.Size = new System.Drawing.Size(139, 346);
-      this.treeView1.TabIndex = 0;
+      // tvClientControl
+      // 
+      this.tvClientControl.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.tvClientControl.Location = new System.Drawing.Point(0, 0);
+      this.tvClientControl.Name = "tvClientControl";
+      this.tvClientControl.Size = new System.Drawing.Size(139, 346);
+      this.tvClientControl.TabIndex = 0;
       // 
       // listView1
@@ -160,5 +160,5 @@
       // scJobControl.Panel1
       // 
-      this.scJobControl.Panel1.Controls.Add(this.treeView3);
+      this.scJobControl.Panel1.Controls.Add(this.tvJobControl);
       // 
       // scJobControl.Panel2
@@ -169,11 +169,11 @@
       this.scJobControl.TabIndex = 1;
       // 
-      // treeView3
-      // 
-      this.treeView3.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.treeView3.Location = new System.Drawing.Point(0, 0);
-      this.treeView3.Name = "treeView3";
-      this.treeView3.Size = new System.Drawing.Size(139, 346);
-      this.treeView3.TabIndex = 2;
+      // tvJobControl
+      // 
+      this.tvJobControl.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.tvJobControl.Location = new System.Drawing.Point(0, 0);
+      this.tvJobControl.Name = "tvJobControl";
+      this.tvJobControl.Size = new System.Drawing.Size(139, 346);
+      this.tvJobControl.TabIndex = 2;
       // 
       // listView3
@@ -205,5 +205,5 @@
       // scUserControl.Panel1
       // 
-      this.scUserControl.Panel1.Controls.Add(this.treeView4);
+      this.scUserControl.Panel1.Controls.Add(this.tvUserControl);
       // 
       // scUserControl.Panel2
@@ -214,11 +214,11 @@
       this.scUserControl.TabIndex = 1;
       // 
-      // treeView4
-      // 
-      this.treeView4.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.treeView4.Location = new System.Drawing.Point(0, 0);
-      this.treeView4.Name = "treeView4";
-      this.treeView4.Size = new System.Drawing.Size(139, 346);
-      this.treeView4.TabIndex = 1;
+      // tvUserControl
+      // 
+      this.tvUserControl.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.tvUserControl.Location = new System.Drawing.Point(0, 0);
+      this.tvUserControl.Name = "tvUserControl";
+      this.tvUserControl.Size = new System.Drawing.Size(139, 346);
+      this.tvUserControl.TabIndex = 1;
       // 
       // listView4
@@ -290,5 +290,5 @@
     private System.Windows.Forms.SplitContainer scClientControl;
     private System.Windows.Forms.TabPage tpUserControl;
-    private System.Windows.Forms.TreeView treeView1;
+    private System.Windows.Forms.TreeView tvClientControl;
     private System.Windows.Forms.ListView listView1;
     private System.Windows.Forms.SplitContainer scJobControl;
@@ -297,6 +297,6 @@
     private System.Windows.Forms.TreeView treeView2;
     private System.Windows.Forms.ListView listView2;
-    private System.Windows.Forms.TreeView treeView3;
-    private System.Windows.Forms.TreeView treeView4;
+    private System.Windows.Forms.TreeView tvJobControl;
+    private System.Windows.Forms.TreeView tvUserControl;
     private System.Windows.Forms.ListView listView4;
   }
Index: /trunk/sources/HeuristicLab.Hive.Server.Console/HiveServerManagementConsole.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.Console/HiveServerManagementConsole.cs	(revision 830)
+++ /trunk/sources/HeuristicLab.Hive.Server.Console/HiveServerManagementConsole.cs	(revision 831)
@@ -28,4 +28,6 @@
 using System.Text;
 using System.Windows.Forms;
+using HeuristicLab.Hive.Contracts.Interfaces;
+using HeuristicLab.Hive.Contracts.BusinessObjects;
 
 namespace HeuristicLab.Hive.Server.Console {
@@ -37,6 +39,36 @@
     public event closeForm closeFormEvent;
 
+    List<ClientGroup> clients = null;
+    List<Job> jobs = null;
+    List<UserGroup> userGroups = null;
+    
     public HiveServerManagementConsole() {
       InitializeComponent();
+
+      IClientManager clientManager =
+        ServiceLocator.GetClientManager();
+
+      IJobManager jobManager =
+        ServiceLocator.GetJobManager();
+
+      IUserRoleManager userRoleManager =
+        ServiceLocator.GetUserRoleManager();
+
+     // clients = clientManager.GetAllClientGroups();
+      jobs = jobManager.GetAllJobs();
+      userGroups = userRoleManager.GetAllUserGroups();
+     // foreach (ClientGroup cg in clients) {
+     //   tvClientControl.Nodes.Add(cg.Name);
+        foreach (ClientInfo ci in clientManager.GetAllClients()) {
+          tvClientControl.SelectedNode.Nodes.Add(ci.name);
+        }
+     // }
+      foreach (Job job in jobs) {
+        tvJobControl.Nodes.Add(job.JobId.ToString());
+      }
+      foreach (UserGroup ug in userGroups) {
+        tvUserControl.Nodes.Add(ug.UserGroupId.ToString());
+      }
+
     }
 